SystemOrganization addCategory: #PrintingDifferently!

TestCase subclass: #PrintingDifferentlyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PrintingDifferently'!

!PrintingDifferentlyTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/3/2014 16:48'!
testPlural
	|romans|
	romans := PrintingDifferently  subjects: (1 to: 10) printOnBlockWithSelfWithStream: [:each :stream| stream nextPutAll: each printStringRoman ].
	self assert: (romans at: 3) printString equals: 'III'.
	self assert: (romans at: 4) printString equals: 'IV'.
	
	self should: [(romans at: 3)+(romans at: 4)] raise: Error. 
	self assert: (romans at: 3)+4 equals: 7 ! !

!PrintingDifferentlyTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/3/2014 16:49'!
testSingular
	|roman|
	roman := PrintingDifferently  subject: 3 printOnBlockWithSelfWithStream: [:each :stream| stream nextPutAll: each printStringRoman ].
	
	self assert: (roman printString) equals: 'III'.
	self assert: (roman+4) equals: 7.! !

Object subclass: #PrintingDifferently
	instanceVariableNames: 'printOnBlock objectBeingPrintedDifferently'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PrintingDifferently'!

!PrintingDifferently class methodsFor: 'instance creation' stamp: 'HwaJong 12/1/2012 01:37'!
subject: anObject printOnBlockWithSelfWithStream: twoArgBlock
^self new
	objectBeingPrintedDifferently: anObject;
	twoArgBlockThatWillPrintDifferently: twoArgBlock 
! !

!PrintingDifferently class methodsFor: 'instance creation' stamp: 'HwaJong 2/3/2014 16:41'!
subjects: aCollection printOnBlockWithSelfWithStream: twoArgBlock

	^aCollection collect: [:each| self subject: each printOnBlockWithSelfWithStream: twoArgBlock ].! !

!PrintingDifferently methodsFor: 'error handling' stamp: 'HwaJong 12/1/2012 01:36'!
doesNotUnderstand: aMessage
	^aMessage sendTo: objectBeingPrintedDifferently! !

!PrintingDifferently methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 01:36'!
objectBeingPrintedDifferently
^objectBeingPrintedDifferently! !

!PrintingDifferently methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 01:36'!
objectBeingPrintedDifferently: anObject
objectBeingPrintedDifferently := anObject! !

!PrintingDifferently methodsFor: 'printing' stamp: 'HwaJong 12/1/2012 01:36'!
printOn: aStream
printOnBlock value: objectBeingPrintedDifferently value: aStream.! !

!PrintingDifferently methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 01:33'!
twoArgBlockThatWillPrintDifferently: twoArgBlock 
printOnBlock := twoArgBlock ! !
